*******************************************************************************
CHANGE LOG
===============================================================================

BMS Monitor for Control4 driver
-------------------------------------------------------------------------------
Version    417
Date       09-06-2026

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- N/A

BUG FIXES
- Fixed startup bug that could occur for new installations in v416

-------------------------------------------------------------------------------
Version    416
Date       29-05-2026

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- Added the option to create a stacked pie chart
- Updated Smart Meter screens
- Optimised memory usage for rapidly updating variables
- Added 2 additional icons: Info (i), Sprinkler
- Reduced webview load time by compacting hidden screens

BUG FIXES
- Fixed variable sort order for pie charts

-------------------------------------------------------------------------------
Version    415
Date       17-04-2026

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- Increased touch area on bar chart statistics button
- Bar chart statistics can be held open (via pin icon)
- In value display widgets, timeline variables now have icon selection per-state
- Display text can be specified for each state of timeline variables
- Add the thousands seperator for y-axis labels

BUG FIXES
- Viewing data from a different timezone now shows the full dataset in the controllers timezone
- New meters now appear for Smart Meter widget
- Variable selection changes are now shown in the graph edit preview
- Fixed variable value highlight jumping
- A dual scatter-bar graph with 1 bar and 1 line now has a legend

-------------------------------------------------------------------------------
Version    413
Date       31-03-2026

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- Add the option to choose colours for the screen icons
- Added the option to choose the line style (solid / dashed)

BUG FIXES
- Scatter graphs with dynamic scaling are now properly displayed
- Negative values are now properly displayed for bar charts
- Y-axis ticks for bar charts show an appropriate number of decimal places
- Fixed processor crash that could occur when the clocks go forward

-------------------------------------------------------------------------------
Version    412
Date       11-03-2026

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- Added new graph type: Value Display
- Added new graph type: Image Display

BUG FIXES
- Fixed layout creation for elements which didn't already have a layout configuration

-------------------------------------------------------------------------------
Version    411
Date       25-02-2026

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- Improved default sort order on upgrade from v3xx
- Time range is retained when switching between graphs of the same type

BUG FIXES
- Fixed variable registration for the Variable Logger helper driver
- Custom names with non-standard characters can now be stored
- Timeline-only graphs are now properly left-aligned
- Fixed layout for elements which contain multiple pie charts
- Timeline variables are now displayed based on sort order

-------------------------------------------------------------------------------
Version    410
Date       30-01-2026

DRIVER COMPATIBILITY
- Added dashboard view for Watergate Sonic Leak Detector

ENHANCEMENTS
- Added the ability to change the display order for variables within a graph
- Aligned tooltips for scatter and bar charts
- Each element can now be individually configured
- Improved data retrieval efficiency
- Added new graph types: Dual-axis scatter and Dual-axis scatter+bar

BUG FIXES
- Fixed issue with some bar charts rendering abnormally wide bars
- Timeline-only graphs rendered with proper height

-------------------------------------------------------------------------------
Version    405
Date       10-10-2025

DRIVER COMPATIBILITY
- Added support for Watergate Sonic Leak Detector
- Added support for ABB SCU200

ENHANCEMENTS
- Added the ability to tile the layout of elements within a view
- Configuration for each element can now be adjusted in the config popups
- Improved time range selector
- Added full-screen option for each element

BUG FIXES
- Fixed issues causing significant processor slowdown on some systems
- Corrected assignment of bar chart data into windows for multi-hour windows on the weekly view

-------------------------------------------------------------------------------
Version    400
Date       18-06-2025

DRIVER COMPATIBILITY
- Added Humidify Setpoint, Dehumidify Setpoint, Humidity Mode and Humidity State variables for thermostats
- Added ABSENCE variable for Steinel True Presence

ENHANCEMENTS
- Completely re-designed UI for a smoother experience
- Added support for sorting screens with a drag-and-drop folder structure in the sidebar
- Slide across a graph to reveal a tooltip for accurate data reporting
- Variables can be temporarily hidden by clicking on the variable name in the legend
- Added property 'Startup Delay'
- Added property 'Allow Hidden Screens to be Visible'
- Increased maximum number of views to 20

BUG FIXES
- Old un-usable data is now deleted to reduced driver size

-------------------------------------------------------------------------------
Version    332
Date       06-01-2025

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- Added new property 'Startup Delay'

BUG FIXES
- N/A

-------------------------------------------------------------------------------
Version    331
Date       03-07-2024

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- N/A

BUG FIXES
- Fix histroic daily value calculation

-------------------------------------------------------------------------------
Version    330
Date       18-06-2024

DRIVER COMPATIBILITY
- Added support for GivEnergy via DriverCentral

ENHANCEMENTS
- N/A

BUG FIXES
- N/A

-------------------------------------------------------------------------------
Version    329
Date       04-06-2024

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- N/A

BUG FIXES
- Fixed bug where a nonsensical horizontal line could appear for some scatter graphs

-------------------------------------------------------------------------------
Version    328
Date       31-05-2024

DRIVER COMPATIBILITY
- Added support for Smappee
- Added temperature variables for Shelly (Janus)
- Added support for Shelly ProEM and Shelly Pro2PM

ENHANCEMENTS
- Upgraded OpenWeatherMap to use OneCall3.0, as OneCall2.5 is now deprecated
- Behind the scenes optimisations for connection management

BUG FIXES
- N/A

-------------------------------------------------------------------------------
Version    327
Date       04-03-2024

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- N/A

BUG FIXES
- Fixed bug where bar chart variables added through Variable Logger would show incorrect data on the most recent day

-------------------------------------------------------------------------------
Version    326
Date       08-02-2024

DRIVER COMPATIBILITY
- Added POWER_VOLTAGE variable for Wattbox

ENHANCEMENTS
- N/A

BUG FIXES
- Fixed error where data would sometimes fail to be shown from the Control4 app

-------------------------------------------------------------------------------
Version    325
Date       16-01-2024

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- N/A

BUG FIXES
- Scatter variables without data no longer show up on the legend

-------------------------------------------------------------------------------
Version    324
Date       12-01-2024

DRIVER COMPATIBILITY
- Added support for Shelly Pro2PM, ProEM andPro3EM
- Added support for KNX Smart Meter

ENHANCEMENTS
- N/A

BUG FIXES
- Fixed duplicated data for outdoor temperature forecast
- Fixed initialisation of Shelly EM screens

-------------------------------------------------------------------------------
Version    323
Date       14-12-2023

DRIVER COMPATIBILITY
- Added support for GivEnergy
- Added support for Enphase
- Added support for Brainboxes Remote IO
- Added support for DriverCentral variants of the Shelly EM suite

ENHANCEMENTS
- N/A

BUG FIXES
- N/A

-------------------------------------------------------------------------------
Version    322
Date       14-12-2023

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- N/A

BUG FIXES
- Fixed upgrade mechanism for TEMPERATURE => TEMPERATURE_C / TEMPERATURE_F
- Fixed upgrade mechanism for screens

-------------------------------------------------------------------------------
Version    321
Date       08-12-2023

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- Memory logging is enabled by default

BUG FIXES
- Fixed issue on new installations that prevented the screens for being correctly installed

-------------------------------------------------------------------------------
Version    319
Date       06-12-2023

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- N/A

BUG FIXES
- Fixed issue that could cause daily consumption statistics to be under-reported

-------------------------------------------------------------------------------
Version    318
Date       04-12-2023

DRIVER COMPATIBILITY
- Added TOTAL_CONSUMPTION as a variable in the KNX_MONITOR screen

ENHANCEMENTS
- N/A

BUG FIXES
- Prevented superfluous error shown when OpenWeatherMap starts up
- Implemented workaround for KNX Monitor units not being retrieved on startup

-------------------------------------------------------------------------------
Version    317
Date       17-11-2023

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- Added display optimisations for scatter data during large value changes

BUG FIXES
- Cloud data deletion now work as intended
- Controller's UTC offset is regularly updated, to account for when daylight savings changes

-------------------------------------------------------------------------------
Version    316
Date       01-11-2023

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- Added missing translations for PolarBear Zentium

BUG FIXES
- Fixed issue where a gradually changing value would continually be overwritten

-------------------------------------------------------------------------------
Version    314
Date       26-10-2023

DRIVER COMPATIBILITY
- Added support for PolarBear Design UMC RS1
- Added support for floor temperature variables, if they exist

ENHANCEMENTS
- Added missing translations for Czech, German, French, Romanian

BUG FIXES
- N/A

------------------------------------------------------------------------------
Version    313
Date       24-10-2023

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- N/A

BUG FIXES
- Ensured diagonal line cannot appear for stepped graphs
- Fixed issue that could prevent older data from showing if the variable hasn't been updated today
- Unregisters variable listeners when variables are removed

-------------------------------------------------------------------------------
Version    312
Date       17-10-2023

DRIVER COMPATIBILITY
- Added support for GivEnergy
- Added support for Centralized Lighting Room Monitor

ENHANCEMENTS
- Further optimised driver to reduce memory usage at runtime even more
- Updated driver name, creator and composer categories

BUG FIXES
- Fixed error that could occur within data compression

-------------------------------------------------------------------------------
Version    311
Date       13-10-2023

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- Optimised driver to reduce memory usage at runtime
- Added DRIVER_MEMORY_KB and PERSISTENT_DATA_SIZE_KB variables
- Data is compressed less when viewing from a web browser

BUG FIXES
- Memory usage logging now logs an accurate value
- Reduced page size for non-cloud variables back from 300 to 100

-------------------------------------------------------------------------------
Version    310
Date       10-10-2023

DRIVER COMPATIBILITY
- Added support for text value variable for the KNX Generic Monitor

ENHANCEMENTS
- Older data is offloaded to the cloud, to reduce driver memory usage
- Webview will automatically update with new data when available
- Added French localisation

BUG FIXES
- Fixed position of pie chart statistics for negative values
- Y axis indicators below the minimum value no longer rendered
- Fixed 2 startup bugs when upgrading driver version

-------------------------------------------------------------------------------
Version    304
Date       11-09-2023

DRIVER COMPATIBILITY
- Added support for C4Z number variable driver

ENHANCEMENTS
- N/A

BUG FIXES
- N/A

-------------------------------------------------------------------------------
Version    303
Date       04-09-2023

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- N/A

BUG FIXES
- Fixed numerical inputs, allowing direct entering for negative values

-------------------------------------------------------------------------------
Version    302
Date       27-07-2023

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- Up to 10 views allowed for custom screens
- Improved configuration layout for mobile devices
- Updated Czech translations

BUG FIXES
- Labels should no longer overlap for pie charts
- Fixed thermostat upgrades from v1xx to v3xx
- Fixed crash in the webview
- Fixed bug preventing you from deleting custom screens

-------------------------------------------------------------------------------
Version    301
Date       22-05-2023

DRIVER COMPATIBILITY
- Add support for Shelly NG Module by ChowMain

ENHANCEMENTS
- Added option to hide negative values on bar, line and pie graphs

BUG FIXES
- Pie chart scaling for outlet power usage for Wattbox and Aten EcoPDU fixed
- Ensured that initial variable values are stored in the database at startup
- Fixed styling in userguides caused by overflowing images
- Reduced initial data override to 5 minutes

-------------------------------------------------------------------------------
Version    300
Date       20-04-2023

DRIVER COMPATIBILITY
- Added support for Aten EcoPDU range
- Added support for Wattbox
- Added support for bTimer by bNetSolutions

ENHANCEMENTS
- Added new Energy Dashboard feature
- Swipe on a screen to switch between available views
- Variables are rate-limited to prevent the database from being flooded with rapidly updating variables
- Consumption variables are compressed daily to reduce memory usage and increase data storage duration
- Driver will detect if project temperature scale changes at runtime
- Initial value of monitored variables is now shown immediately
- Sidebar no longer fully disappears for portrait displays
- Added property 'Allow Screen Configuration'
- Added option in webview configuration, 'Stacked' for bar charts
- Data is displayed in the timezone of the C4 controller
- Negative values for pie and bar charts are displayed sensibly

BUG FIXES
- Fixed sidebar overflowing if you have too many devices on portrait displays
- Improved readability of OpenWeatherMap error messages
- Removed warning that 'C' is an invalid locale
- Data is now only sent to the client that requested it, preventing badly scaled data from being displayed
- Min/Max for instantaneous values re-calculated if current value goes outside that range

-------------------------------------------------------------------------------
Version    220
Date       07-12-2022

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- Added 'Dynamic' option to the property 'Start Week on'
- Added Zentium Floor Limits to diagnostic views

BUG FIXES
- Variables list is now scrollable again
- Adding a custom screen no longer crashes the webview
- 'Show Statistics' is now honoured for pie charts

-------------------------------------------------------------------------------
Version    218
Date       29-11-2022

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- Added Zentium TwoPipe status logging (on Diagnostic View)

BUG FIXES
- N/A

-------------------------------------------------------------------------------
Version    217
Date       28-11-2022

DRIVER COMPATIBILITY
- Moved view selectors for portrait displays

ENHANCEMENTS
- N/A

BUG FIXES
- Graphs no longer overflow off the right side of the screen
- Labels in pie charts are now sized correctly relative to the chart itself

-------------------------------------------------------------------------------
Version    216
Date       25-11-2022

DRIVER COMPATIBILITY
- Added additional Zentium diagnostic view

ENHANCEMENTS
- N/A

BUG FIXES
- N/A

-------------------------------------------------------------------------------
Version    215
Date       23-11-2022

DRIVER COMPATIBILITY
- Added support for Shelly EM3, by Eagis
- Added support for additional Zentium variables

ENHANCEMENTS
- N/A

BUG FIXES
- N/A

-------------------------------------------------------------------------------
Version    213
Date       10-11-2022

DRIVER COMPATIBILITY
- Added support for Shelly EM3, 1PM, Pro1PM, Pro4PM

ENHANCEMENTS
- N/A

BUG FIXES
- N/A

-------------------------------------------------------------------------------
Version    211
Date       24-08-2022

DRIVER COMPATIBILITY
- Added support for German translations

ENHANCEMENTS
- Removed empty persistent data entries to dramatically reduce driver size

BUG FIXES
- N/A

-------------------------------------------------------------------------------
Version    209
Date       06-07-2022

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- Added support for User-created variables in the Variable Logger driver

BUG FIXES
- N/A

-------------------------------------------------------------------------------
Version    208
Date       26-05-2022

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- N/A

BUG FIXES
- Added missing translations
- Fixed thermostats failing to initialise

-------------------------------------------------------------------------------
Version    206
Date       25-05-2022

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- Added option to disable min/max/average for instantaneous values
- Improved screen editing for narrow devices

BUG FIXES
- T3/T4 screens use the correct communication method in OS3.3
- Fixed bottom of webview getting cut off on modern iOS devices

-------------------------------------------------------------------------------
Version    205
Date       31-03-2022

DRIVER COMPATIBILITY
- Added support for UI Key - Status Button driver

ENHANCEMENTS
- Added support for Romanian translations
- Added property 'Webview Link' to provide browser access to the BMS Monitor interface
- When editing variable colours for a custom screen, the device name is visible in the popup title

BUG FIXES
- N/A

-------------------------------------------------------------------------------
Version    204
Date       02-03-2022

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- For portrait displays, the sidebar can now be hidden
- Improved localisation responsiveness

BUG FIXES
- Fixed startup issue on OS3.3+
- Views with 2 instantaneous values appropriately displayed
- Added missing translations for Italian and Czech localisation

-------------------------------------------------------------------------------
Version    202
Date       13-01-2022

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- N/A

BUG FIXES
- Fixed issue where screens could not be edited on mobile devices

-------------------------------------------------------------------------------
Version    201
Date       10-12-2021

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- Added support for Italian translations
- Changed device selector toolbar to use icons

BUG FIXES
- N/A

-------------------------------------------------------------------------------
Version    200
Date       03-12-2021

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- Added mobile webview functionality from the iOS/android app

BUG FIXES
- N/A

-------------------------------------------------------------------------------
Version    143
Date       29-11-2021

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- Cloud backups are split into multiple banks to allow larger backups

BUG FIXES
- N/A

-------------------------------------------------------------------------------
Version    142
Date       24-11-2021

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- Cloud backups are compressed to save storage, and allow larger backups

BUG FIXES
- N/A

-------------------------------------------------------------------------------
Version    141
Date       17-11-2021

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- N/A

BUG FIXES
- Variables in the European locale format no longed discarded
- Fixed startup issue affecting processors on European locales

-------------------------------------------------------------------------------
Version    140
Date       12-11-2021

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- N/A

BUG FIXES
- Prevents temperatures for the pool proxy from sporadically dropping to 0
- Prevents temperatures for the thermostat proxy from sporadically dropping to 0
- Connect state no longer shown in English for Czech locales

-------------------------------------------------------------------------------
Version    139
Date       11-11-2021

DRIVER COMPATIBILITY
- Added support for the pool proxy
- Shelly Module (Chowmain) - added power consumption and usage variable that had been changed

ENHANCEMENTS
- Added Czech localisation
- Added warning indicating if the driver filename has been changed

BUG FIXES
- Fixed issue where an invalid controller locale would cause a crash on initialisation
- Non-ascii characters in screen/driver names no longer prevent the webview from rendering

-------------------------------------------------------------------------------
Version    136
Date       20-10-2021

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- N/A

BUG FIXES
- Fixed issue where temperature and setpoint variables would always be hidden on systems in F

-------------------------------------------------------------------------------
Version    135
Date       19-10-2021

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- N/A

BUG FIXES
- Fixed issue where an attempt to compress timeline variables would prevent data from being displayed

-------------------------------------------------------------------------------
Version    134
Date       19-10-2021

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- Changed temperature variables for thermostats to use TEMPERATURE_C and TEMPERATURE_F
- Allow the week to start on different days (Monday/Saturday/Sunday)
- When viewing the daily view of a bar graph, you can toggle between a window size of 1 hour and 10 minutes

BUG FIXES
- Fixed issue where data resolution wouldn't change for bar+timeline graphs

-------------------------------------------------------------------------------
Version    133
Date       10-09-2021

DRIVER COMPATIBILITY
- Added support for the third phase in Shelly IoT 3EM devices

ENHANCEMENTS
- When viewing the weekly view of a bar graph, you can toggle between a window size of 1 day and hourly

BUG FIXES
- Fixed issue where duplicate view names would not be cleared from the view switching buttons
- Custom views displaying pie charts now refresh their displayed data regularly

-------------------------------------------------------------------------------
Version    131
Date       27-08-2021

DRIVER COMPATIBILITY
- Added support for Shelly IoT EM (by ChowMain)
- Added support for Shelly EM (by Kiwifarm)

ENHANCEMENTS
- N/A

BUG FIXES
- N/A

-------------------------------------------------------------------------------
Version    130
Date       17-08-2021

DRIVER COMPATIBILITY
- Added support for Variable Logger by Janus

ENHANCEMENTS
- N/A

BUG FIXES
- Fixed issue where adding consumption variables to a new view sometimes failed
- Consumption usage labels now accurate for slow variables that reset on regular intervals

-------------------------------------------------------------------------------
Version    129
Date       02-08-2021

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- T4 screens are now selectable for the 'Clear Touchscreen Cache' action
- Added Singleton driver warning

BUG FIXES
- Consumption usage labels now accurate for variables that reset on regular intervals
- Fixed issue introduced in Version    128 preventing custom screens from being added

-------------------------------------------------------------------------------
Version    128
Date       08-07-2021

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- Units for eGauge energy consumption set to 'kWh'
- Added comma separators for reported usage (e.g. 1000 -> 1,000)
- Check backup size, and if it would exceed AWS Lambda limit, then reduce number of days of data backed up

BUG FIXES
- N/A

-------------------------------------------------------------------------------
Version    127
Date       05-07-2021

DRIVER COMPATIBILITY
- Added support for Shelly IoT EM (by Janus)

ENHANCEMENTS
- Allow choosing custom colours and states for timeline variables
- When viewing the yearly view of a bar graph, you can toggle between a window size of 1 day and 1 month
- Displays usage for the viewed time period for bar graphs
- Allow creating a custom instantaneous (pie) view
- Minor style changes to the devices sidebar and speedometer graphs
- Enabled LuaJIT

BUG FIXES
- Custom screens that were deleted prior to a driver reboot now stay deleted

-------------------------------------------------------------------------------
Version    126
Date       09-04-2021

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- Allows changing the colour of line/bar graphs for device screens

BUG FIXES
- Fixed issue where switching to an instantaneous view from a historic one would sometimes fail
- Fixed a crash that occurred when restoring data to a variable without much stored data
- Combined Instantaneous/Scatter variable types now display dynamic scaling correctly
- Increased CloudBackup timeout to prevent backup failures
- Daily average indication always shown for monthly consumption views, even if out of range of displayed data

-------------------------------------------------------------------------------
Version    125
Date       11-03-2021

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- Exposed OpenWeatherMap API Key in driver properties

BUG FIXES
- N/A

-------------------------------------------------------------------------------
Version    124
Date       19-02-2021

DRIVER COMPATIBILITY
- N/A

ENHANCEMENTS
- N/A

BUG FIXES
- Fixed display for pie charts which was broken in Version    123

-------------------------------------------------------------------------------
Version    123
Date       18-02-2021

DRIVER COMPATIBILITY
- Added support for Eaton energy sensor
- Added support YATUN modbus generic monitor

ENHANCEMENTS
- Added button on the webview to show hidden screens
- Added the option to choose dynamic or set scaling for custom screens
- Introduced interpolation type configuration properties for certain driver types

BUG FIXES
- Adding a new custom screen now defaults to 'Visible'
- Outdoor temperature & humidity forecast will now match colours on custom screens
- Temperature/humidity forecast is now visible in hourly views

-------------------------------------------------------------------------------
Version    122
Date       02-02-2020

ENHANCEMENTS
- N/A

BUG FIXES
- Multiple instances of KNX monitor should allow for interpolation type to be adjusted separately

-------------------------------------------------------------------------------
Version    121
Date       01-02-2020

ENHANCEMENTS
- Improved data compression

BUG FIXES
- Custom screens now correctly go through the update procedure
- Data compression now ensures data is drawn fully to the end time where applicable

-------------------------------------------------------------------------------
Version    120
Date       29-01-2020

DRIVER COMPATIBILITY
- Added support for YATUN Number Variable drivers

ENHANCEMENTS
- Custom bar views now have dynamic scaling set as default
- Added screen configuration options for view range
- Added option to hide a screen within configuration options
- Custom screens now included in cloud backups
- Added an event for when a cloud backup fails
- Allows KNX Monitor driver to display current value as scatter or staircase

BUG FIXES
- Fixed issue where you could not restore a cloud backup
- Fixed a few issues in view switching for bar graphs
- Fixed issue where you could not change the line colours on a previously created screen
- Fixed issue where the most recent 2 values would be ignored during data compression

-------------------------------------------------------------------------------
Version    119
Date       15/12/2020

ENHANCEMENTS
- Improved variable registration reliability

BUG FIXES
- Fixed issue where a monitored driver with a delayed startup would log incorrect values

-------------------------------------------------------------------------------
Version    118
Date       11/12/2020

ENHANCEMENTS
- Text colour is set to black for light backgrounds
- Variable registration improvements

BUG FIXES
- Fixed startup crash for BMS Monitor Lite

-------------------------------------------------------------------------------
Version    117
Date       10/12/2020

ENHANCEMENTS
- Added customisable screens - create your own combinations of devices and variables to be monitored on the same view
- Added new app icons for iOS and android webpage favourites
- Added additional icons for screen icon selection
- Y-axis scaling shows more sensible intervals
- Database cleared of old screens that are no longer monitored on startup
- Added a custom command, allowing cloud backups to be scheduled
- Added key events to buttons with click events, allowing full control of BMS Monitor without a mouse

BUG FIXES
- Fixed issue where custom scaling would sometimes be lost on a driver reboot
- Fixed issue where instantaneous views would not show the correct current value
- Fixed issue where renaming some drivers would not update the webview
- Temperature display drivers prevented from showing HVAC mode/state graphs
- Z2IO and Z2C drivers no longer show a duplicate 'Humidity' field in the edit popup
- Fixed issue where saving a backup to the cloud would not save all data if the DB has expanded since the last reboot

-------------------------------------------------------------------------------
Version    116
Date       14-10-2020

DRIVER COMPATIBILITY
- Added compatibility with Control4 Z2IO and Z2C drivers

ENHANCEMENTS
- Enabled KNX Monitor to display a history for some instantaneous values
- Enabled Humidity view to be visible for Control4 Residential Thermostat drivers
- Added driver sorting mechanism
- Behind the scenes cloud backup improvements

BUG FIXES
- Fixed issue where blank views would exist for KNX Monitor drivers if only 1 datapoint was being used

-------------------------------------------------------------------------------
Version    115
Date       17-09-2020

ENHANCEMENTS
- Rate-limited cloud backups to 1 per 8 hours

BUG FIXES
- Cloud backup failures in European locales handled to fail gracefully - cloud fix to follow

-------------------------------------------------------------------------------
Version    114
Date       15-09-2020

DRIVER COMPATIBILITY
- Added support for KNX Generic Monitor

ENHANCEMENTS
- N/A

BUG FIXES
- Fixed issue where deleting a monitored driver would cause a startup error on next reboot

-------------------------------------------------------------------------------
Version    113
Date       15-09-2020

DRIVER COMPATIBILITY
- Added support for eGauge Monitor
- Added support for North Generic Monitor

ENHANCEMENTS
- Added screen configuration popup, accessed by holding a device on the sidebar
- Screen configuration - added icon selector
- Screen configuration - added adjustable Y axis limits
- Screen configuration - added view title & y axis label fields
- Outdoor Temperature & temperature forecast scale (C/F) now taken from project properties
- Added text to indicate when there is no data to be displayed

BUG FIXES
- Fixed issue where no data would appear when switching from a thermostat with humidity to one without
- Setpoints and HVAC mode/state are now monitored for the Control4 residential thermostat V2

-------------------------------------------------------------------------------
Version    112
Date       23-07-2020

ENHANCEMENTS
- N/A

BUG FIXES
- Fixed issue where drivers displaying multiple bar vars would have a data resolution that is much too small

-------------------------------------------------------------------------------
Version    111
Date       20-07-2020

ENHANCEMENTS
- Increased startup delay - for heavily loaded systems

BUG FIXES
- Fixed calculate of daily consumption for Flo by Moen
- Work-around for DAILY_CONSUMPTION variable for Flo by Moen sometimes showing a small reduction (without wrapping around)

-------------------------------------------------------------------------------
Version    109
Date       17-07-2020

DRIVER COMPATIBILITY
- Added support for Flo by Moen water meter

ENHANCEMENTS
- N/A

BUG FIXES
- N/A

-------------------------------------------------------------------------------
Version    108
Date       09-07-2020

DRIVER COMPATIBILITY
- Added support for Thermostat Version    1 drivers

ENHANCEMENTS
- Added 'Lite' version of the driver, supporting monitoring of only 1 driver of each type
- Added outdoor humidity monitoring, displayed alongside any humidity view for compatible thermostats
- Added warning message in webview, indicating when the driver is unlicensed (demo expired)

BUG FIXES
- Fixed issue where the driver icon would not be displayed correctly in the Control4 UI
- Reduced rate that OpenWeatherMap requests the forecast, minimising the risk of number of requests exceeding the daily maximum

-------------------------------------------------------------------------------
Version    107
Date       02-07-2020

ENHANCEMENTS
- Set date range to 'today' for instantaneous views

BUG FIXES
- Fix hard-coded driver name that caused 404 error on T3 screens

-------------------------------------------------------------------------------
Version    106
Date       20-06-2020

ENHANCEMENTS
- N/A

BUG FIXES
- Fixed issue with invalid data not being excluded from Database (eg 0 TEMPERATURE on startup)

-------------------------------------------------------------------------------
Version    105
Date       19-06-2020

DRIVER COMPATIBILITY
- Added support for Herolabs Sonic Leak Detector, which monitors water consumption
- Added support for KNX utility metering
- Added humidity support via ThermostatV2 proxy

ENHANCEMENTS
- Implemented new time selector controls, allowing custom data ranges
- Added ability to smooth excessively noisy data to reduce number of samples sent to webview
- Added icons to the device selector to indicate device type
- Added localization to support Slovak and Czech characters in device names

BUG FIXES
- Fixed startup issue where thermostat temperature/setpoint would jump to 0 for a moment
- Temperature display drivers no longer display irrelevant HVAC mode, HVAC state and setpoint
- Removed horizontal line in outdoor temperature (thermostats) line that appears 48hours+ into the future
- Fixed comms failure with OpenWeatherMap API
- Fixed issue where a UUID for cloud backups would not be assigned on initialisation

-------------------------------------------------------------------------------
Version    104
Date       12-05-2020

ENHANCEMENTS
- Added cloud backup/restore functionality
- Added outdoor temperature + forecast to be displayed alongside thermostat temperatures and setpoints
- Graph control timescales start and end at 00:00 on the respective days

BUG FIXES
- Fixed BMS Monitor appearing as a monitored device in webview
- Fixed crash when viewing a range that had no data

-------------------------------------------------------------------------------
Version    103
Date       27-04-2020

DRIVER COMPATIBILITY
- Added support for split setpoints
- Added support for both fahrenheit and celsius

ENHANCEMENTS
- Added horizontal stacked bars for HVAC Mode and State (monitored thermostats)
- Added user guide
- Added DriverCentral licensing version
- Supports driver name changes

BUG FIXES
- HVAC Mode and HVAC State always display in the same order for all thermostats

-------------------------------------------------------------------------------
Version    102
Date       11-04-2020

ENHANCEMENTS
- Clears the database when a driver is removed from the project
- Added lights as a monitored device type
- Added icons for the Control4 UI
- Added 'yesterday' scale option for the webview graph
- Improved calculation for min/max variable values for the webview graph

BUG FIXES
- Retrieval of staircase values fixed so that it doesn't overflow to before the variable was being monitored

-------------------------------------------------------------------------------
Version    101
Date       03-03-2020

ENHANCEMENTS
- N/A

BUG FIXES
- Fixed webview so that it displays on both browsers and T3 touch screens

-------------------------------------------------------------------------------
Version    100
Date       02-03-2020

- Initial release
